package name.panitz.util

sealed class List<out T>
object Nil: List<Nothing>(){
  override fun toString(): String ="Nil"
}
data class Cons<out T>(val hd:T,val tl:List<T>):List<T>()

fun <A> isEmpty(xs:List<A>):Boolean

fun <A> length(xs:List<A>):Int

fun <A> last(xs:List<A>):A

fun <A> append(xs:List<A>, ys:List<A>):List<A>

fun <A> take(xs:List<A>,n:Int):List<A>

fun <A,B> map(xs:List<A>,f:(A)->B):List<B>

fun <A> forEach(xs:List<A>,f:(A)->Unit):Unit

fun <A> filter(xs:List<A>,p:(A)->Boolean):List<A>

fun <A,B> fold(xs:List<A>,s:B,op:(B,A)->B): B

fun <A> reverse(xs:List<A>):List<A>

fun <A> concat(xss:List<List<A>>):List<A>

fun sum(xs:List<Int>):Int